/*
 File: pass3.h
 Date and Time: Fri Jan 30 18:55:20 2015 
*/
#ifndef __pass3_h__
#define __pass3_h__ 1
#include "yacco2.h"
#include "yacco2_T_enumeration.h"
#include "yacco2_k_symbols.h"
#include "yacco2_err_symbols.h"
#include "yacco2_terminals.h"
#include "yacco2_characters.h"

#include "ws.h"
#include "cweb_or_c_k.h"
#include "bad_char_set.h"
#include "eol.h"
#include "prefile_include.h"
#include "identifier.h"
#include "o2_externs.h"
  
// monolithic grammar: no thread
extern yacco2::State S1_Cpass3;
namespace NS_pass3 {
using namespace NS_yacco2_T_enum;// enumerate
using namespace yacco2;
struct fsm_rules_reuse_table_type{
 fsm_rules_reuse_table_type();
 int no_rules_entries_;
 Per_rule_s_reuse_table* per_rule_s_table_[4];
};
class Cpass3: public yacco2::CAbs_fsm {
 public:
  enum rules_and_subrules{
   start_of_rule_list = NS_yacco2_T_enum::T_Enum::sum_total_T
   ,R_Rpass3_ = 569//start_of_rule_list + 0
    ,rhs1_Rpass3_ = 1
    ,rhs2_Rpass3_ = 2
   ,R_Relems_ = 570//start_of_rule_list + 2
    ,rhs1_Relems_ = 3
    ,rhs2_Relems_ = 4
   ,R_Rtoken_ = 571//start_of_rule_list + 4
    ,rhs1_Rtoken_ = 5
    ,rhs2_Rtoken_ = 6
    ,rhs3_Rtoken_ = 7
    ,rhs4_Rtoken_ = 8
    ,rhs5_Rtoken_ = 9
    ,rhs6_Rtoken_ = 10
    ,rhs7_Rtoken_ = 11
    ,rhs8_Rtoken_ = 12
    ,rhs9_Rtoken_ = 13
    ,rhs10_Rtoken_ = 14
    ,rhs11_Rtoken_ = 15
    ,rhs12_Rtoken_ = 16
    ,rhs13_Rtoken_ = 17
    ,rhs14_Rtoken_ = 18
   ,R_Rprefile_inc_dispatcher_ = 572//start_of_rule_list + 6
    ,rhs1_Rprefile_inc_dispatcher_ = 19
    ,rhs2_Rprefile_inc_dispatcher_ = 20
    ,rhs3_Rprefile_inc_dispatcher_ = 21
  };
  //no of la sets = 2
  //no of states = 26
  Cpass3();
  ~Cpass3();
  void op();
  bool failed();
  void reduce_rhs_of_rule
      (yacco2::UINT Sub_rule_no,yacco2::Rule_s_reuse_entry** Recycled_rule);
  fsm_rules_reuse_table_type fsm_rules_reuse_table;
  static int rhs_to_rules_mapping_[22];
  
    public:
static int nested_use_cnt_;
  
 };
struct Rpass3;
struct Relems;
struct Rtoken;
struct Rprefile_inc_dispatcher;
struct Rpass3:public yacco2::CAbs_lr1_sym {
  Rpass3(yacco2::Parser* P);
  void op();
  public:
  void sr1();
  void sr2();
};

struct Relems:public yacco2::CAbs_lr1_sym {
  Relems(yacco2::Parser* P);
  public:
};

struct Rtoken:public yacco2::CAbs_lr1_sym {
  Rtoken(yacco2::Parser* P);
  public:
  void sr3();
  void sr4();
  void sr5();
  void sr6();
  void sr8();
  void sr9();
  void sr10();
  void sr11();
  void sr12();
  void sr13();
  void sr14();
};

struct Rprefile_inc_dispatcher:public yacco2::CAbs_lr1_sym {
  Rprefile_inc_dispatcher(yacco2::Parser* P);
  public:
  void sr1();
  void sr2();
  void sr3();
};

} // end of namespace

#endif
